import { h, createContext, Fragment } from "preact";
import { useRef } from "preact/hooks";
import render from "preact-render-to-string";
export const __DocContext = createContext({
    head: { current: [] },
    hydrate: { current: [] },
});
export const __hydratedComponents = [];
const unique = (value, index, self) => self.indexOf(value) === index;
export const Document = ({ hydrateExportManifest, page, styles = [], hasScripts = false, children, }) => {
    const head = useRef([]);
    const hydrate = useRef([]);
    const subtree = render(h(__DocContext.Provider, { value: { head, hydrate } }, children), {}, { pretty: true });
    const components = hydrate.current.map(({ name }) => name).filter(unique);
    if (hydrate.current.length > 0)
        __hydratedComponents.push({ page, components });
    const componentStyles = components
        .map((name) => {
        const found = hydrateExportManifest.find((entry) => entry.exports.find(([_key, n]) => n === name));
        if (found)
            return found.styles;
        return null;
    })
        .filter((v) => v)
        .join("")
        .trim();
    return (h("html", null,
        h("head", null,
            h("meta", Object.assign({}, { charset: "utf-8" })),
            h("meta", { name: "viewport", content: "width=device-width" }),
            h(Fragment, null, head.current),
            h("style", { dangerouslySetInnerHTML: {
                    __html: "[data-hydrate]{display:contents;}",
                } }),
            styles.map((style) => (h("style", { dangerouslySetInnerHTML: { __html: style.trim() } }))),
            componentStyles && (h("style", { dangerouslySetInnerHTML: { __html: componentStyles } }))),
        h("body", null,
            h("div", { id: "__microsite", dangerouslySetInnerHTML: { __html: subtree } }),
            hydrate.current.length > 0 && (h("script", { type: "module", defer: true, src: `/_hydrate/pages/${page}.js` })),
            hasScripts ? (h(Fragment, null,
                h("script", { type: "module", src: "/index.js" }),
                h("script", Object.assign({}, { nomodule: "" }, { src: "https://unpkg.com/systemjs@2.0.0/dist/s.min.js" })),
                h("script", Object.assign({}, { nomodule: "" }, { src: "/index.legacy.js" })))) : null)));
};
